﻿using System;
using System.IO;
using System.Linq;

namespace SearchingandSorting
{
    class Program
    {
        static void Main(string[] args)
        {
            while (true) // program on a loop
            {
                //The following lines display options to the user
                Console.WriteLine("Select an array to be sorted and searched by inputing the associated number and pressing enter");
                Console.WriteLine();
                Console.WriteLine("1 - Low_256");
                Console.WriteLine("2 - High_256");
                Console.WriteLine("3 - Mean_256");
                Console.WriteLine("4 - Low_2048");
                Console.WriteLine("5 - High_2048");
                Console.WriteLine("6 - Mean_2048");
                Console.WriteLine("7 - Low_4096");
                Console.WriteLine("8 - High_4096");
                Console.WriteLine("9 - Mean_4096");
                Console.WriteLine("10 - Low_256 AND High_256"); //Task 6
                Console.WriteLine("11 - Low_2048 AND High_2048"); //Task 7 
                Console.WriteLine("12 - Low_4096 AND High_4096"); //Task 7 
                Console.WriteLine("13 - EXIT");
                Console.WriteLine();
                Console.Write("Selection: ");
                string ArraySelection = Console.ReadLine(); //Read in user input. Will be processed to select an array to search/sort
                Console.WriteLine();

                switch (ArraySelection)
                {
                    case "1": // low_256
                        Console.Clear(); // clear console before continuing

                        double[] low_256 = (File.ReadAllLines(@"low_256.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); //low_256.txt to double[]

                        SearchSortOption.PickSort(low_256);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double l256s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(low_256, l256s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "2": // high_256
                        Console.Clear(); // clear console before continuing

                        double[] high_256 = (File.ReadAllLines(@"high_256.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // high_256.txt to double[]

                        SearchSortOption.PickSort(high_256);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double h256s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(high_256, h256s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "3": // mean_256
                        Console.Clear(); // clear console before continuing

                        double[] mean_256 = (File.ReadAllLines(@"mean_256.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // mean_256.txt to double[]

                        SearchSortOption.PickSort(mean_256);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double m256s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(mean_256, m256s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;


                    case "4": //low_2048
                        Console.Clear(); // clear console before continuing

                        double[] low_2048 = (File.ReadAllLines(@"low_2048.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // low_2048.txt to double[]

                        SearchSortOption.PickSort(low_2048);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double l2048s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(low_2048, l2048s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "5": // high_2048
                        Console.Clear(); // clear console before continuing

                        double[] high_2048 = (File.ReadAllLines(@"high_2048.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // high_2048.txt to double[]

                        SearchSortOption.PickSort(high_2048);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double h2048s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(high_2048, h2048s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "6": // mean_2048
                        Console.Clear(); // clear console before continuing

                        double[] mean_2048 = (File.ReadAllLines(@"mean_2048.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // mean_2048.txt to double[]

                        SearchSortOption.PickSort(mean_2048);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double m2048s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(mean_2048, m2048s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "7": // low_4096
                        Console.Clear(); // clear console before continuing

                        double[] low_4096 = (File.ReadAllLines(@"low_4096.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // low_4096.txt to double[]

                        SearchSortOption.PickSort(low_4096);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double l4096s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(low_4096, l4096s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "8": //high_4096
                        Console.Clear(); // clear console before continuing

                        double[] high_4096 = (File.ReadAllLines(@"high_4096.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // high_4096.txt to double[]

                        SearchSortOption.PickSort(high_4096);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double h4096s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(high_4096, h4096s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "9": // mean_4096
                        Console.Clear(); // clear console before continuing

                        double[] mean_4096 = (File.ReadAllLines(@"mean_4096.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // mean_4096.txt to double[]

                        SearchSortOption.PickSort(mean_4096);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double m4096s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(mean_4096, m4096s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "10": // TASK 6 - low_256 AND high_256
                        Console.Clear(); // clear console before continuing

                        double[] merged_256 = (File.ReadAllLines(@"merged_256.txt")).Where(s => s != String.Empty).Select(s => double.Parse(s)).ToArray(); // mean_4096.txt to double[]

                        SearchSortOption.PickSort(merged_256);

                        Console.WriteLine();
                        Console.WriteLine();
                        try
                        {
                            Console.Write("Enter a number to search the array for: ");
                            double me256s = double.Parse(Console.ReadLine());
                            Console.WriteLine();
                            SearchSortOption.PickSearch(merged_256, me256s);
                        }
                        catch (Exception)
                        {
                            Console.WriteLine();
                            Console.WriteLine("An error occured.");
                        }

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "11": // TASK 7 - low_2048 AND high_2048
                        Console.Clear(); // clear console before continuing

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "12": // TASK 7 -  low_4096 AND high_4096
                        Console.Clear(); // clear console before continuing

                        Console.WriteLine();
                        Console.WriteLine();
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                    case "13": //EXIT
                        Environment.Exit(1);
                        break;

                    default: // Runs if anything other than 1 - 12 is entered
                        Console.Clear(); // clear console before continuing
                        Console.WriteLine("Invalid entry.");
                        Console.WriteLine("Press any key to continue...");
                        Console.ReadKey();
                        break;

                }
                Console.Clear(); // clear console window before looping back to start
            }

        }
    }
}
