﻿namespace SearchingandSorting
{
    class Quicksort
    {
        public static void Sort(double[] a) // Takes array of doubleing point numbers (doubles)
        {
            Sort(a, 0, a.Length - 1); // Sends array, 0 (left/start value) and array length - 1 (right/end value)
        }

        static void Sort(double[] a, int start, int end)
        {
            double num = a[start]; // variable 'num' is the value at index 0 of the array (to be used as pivot value)

            int i = start - 1; // Used in while loop below
            int j = end + 1; // Used in while loop below

            while (true) //loop
            {
                do
                {
                    i++; // Increment i (move to next element of array)
                } while (a[i] < num); // Increment only while value at a[i] is less than 'num' (then swap method invoked)

                do
                {
                    j--; // Decrement j (move to previous element of array)
                } while (a[j] > num); // Decrement only while value at a[j] is greater than 'num' (then swap method)

                if (i >= j)
                    break; // Ends while loop when i is greater than or equal to j

                Swap(a, i, j); // Envoke swap method (see below) (swaps 2 elements of the array - smaller val to left/ larger to right of 'num')
            }

            //a[i] = num;
            Sort(a, start, j);
            Sort(a, j + 1, end);

        }

        static void Swap(double[] a, int i, int j) // Swap method
        {
            if (i == j)
                return;

            double temp = a[i]; // Temp store for value currently at index a[i] of array
            a[i] = a[j]; // Value of element a[j] assigned to element a[i]
            a[j] = temp; // Value of element a[j] set to value of 'temp' (original value of element a[i])
        }
    }
}