﻿namespace SearchingandSorting
{
    class SortDescending
    {
        // If the array is unsorted:
        public static void UnsortedDescend(double[] array)
        {
            Quicksort.Sort(array); // sort array in ascending order
            Descend(array); // reverse the array
        }


        // If the array is already sorted in ascending order:
        public static void Descend(double[] array)
        {
            int i = 0; // first index of array
            int j = array.Length - 1; // last index of array
            while (i < j)
            {
                double temp = array[i]; // store value currently at array[i] in 'temp'
                array[i] = array[j]; // move value at array[i] to array [j] (at opposite end of the array)
                array[j] = temp; // move value stored in 'temp' to array[j]
                i++; // used to get next element of array
                j--; // used to get previous element of array
            }
        }
    }
}
