﻿using System;

namespace SearchingandSorting
{
    class InsertionSort
    {
        public static void Insertion(double[] array)
        {
            int n = array.Length;

            for (int i = 1; i < n; ++i)
            {
                double key = array[i];
                int j = i - 1;

                // Move elements of arr[0..i-1], 
                // that are greater than key, 
                // to one position ahead of 
                // their current position 
                while (j >= 0 && array[j] > key)
                {
                    array[j + 1] = array[j]; // 1 step
                    j = j - 1; // 1 step
                }
                //array[j + 1] = key; // 1 key
            }

            Console.WriteLine();
        }
    }
}
